package dot7.PortScanner;

import java.awt.*;
import java.awt.event.*;

public class ScannerGUI extends Frame
{
  private TextField tfHost    = null;
  private TextField tfMinPort = null;
  private TextField tfMaxPort = null;
  private Button bScan = null;
  private Button bExit = null;

  private Font f1 = new Font("TimesRoman", Font.BOLD, 32);
  private Font f2 = new Font("TimesRoman", Font.BOLD, 14);
  private Color c1 = new Color(204,204,204);
  private Color c2 = new Color(104,111,129);

  private MenuItem miExit  = null;
  private MenuItem miAbout = null;


  public MenuItem miExit()
  {  return miExit; }
  public MenuItem miAbout()
  {  return miAbout; }

  public String getHost()
  {  return tfHost.getText(); }

  public int getMinPort()
  {
    int returnValue = 0;
    String wrkstr = null;

    wrkstr = tfMinPort.getText();
    try
    {
      returnValue = Integer.parseInt(wrkstr);
    }
    catch (Exception e)
    {
      returnValue = -1;
    }
    return returnValue;
  }

  public int getMaxPort()
  {
    int returnValue = 0;
    String wrkstr = null;

    wrkstr = tfMaxPort.getText();
    try
    {
      returnValue = Integer.parseInt(wrkstr);
    }
    catch (Exception e)
    {
      returnValue = -1;
    }
    return returnValue;
  }

  public Button bScan()
  { return bScan; }

  public Button bExit()
  { return bExit; }


  public ScannerGUI()
  {
    super("PortScanner");
    Panel pMain = new Panel(new BorderLayout());
    pMain.setBackground(c1);

    Label lHeader1 = new Label("Portscanner");
    lHeader1.setFont(f1);
    lHeader1.setBackground(c1);
    lHeader1.setAlignment(Label.CENTER);


    Panel pCenter = new Panel();
    pCenter.setLayout(new GridLayout(3,2));
    Label l1 = new Label("Hostname/IP:  ");
    l1.setFont(f2);
    l1.setBackground(c1);
    tfHost = new TextField("127.0.0.1",10);
    tfHost.setFont(f2);
    tfHost.setBackground(c2);
    Label l2 = new Label("Begin at port: ");
    l2.setFont(f2);
    l2.setBackground(c1);
    tfMinPort = new TextField("1",10);
    tfMinPort.setFont(f2);
    tfMinPort.setBackground(c2);
    Label l3 = new Label("Stop at port:  ");
    l3.setFont(f2);
    l3.setBackground(c1);
    tfMaxPort = new TextField("100",10);
    tfMaxPort.setFont(f2);
    tfMaxPort.setBackground(c2);

    pCenter.add(l1);
    pCenter.add(tfHost);
    pCenter.add(l2);
    pCenter.add(tfMinPort);
    pCenter.add(l3);
    pCenter.add(tfMaxPort);

    Panel pSouth = new Panel();
    pSouth.setBackground(c1);

    bScan = new Button(" Scan ");
    bScan.setFont(f2);
    bExit = new Button(" Exit ");
    bExit.setFont(f2);

    Label lSpace = new Label("");
    lSpace.setBackground(c1);

    pSouth.add(bScan);
    pSouth.add(lSpace);
    pSouth.add(bExit);



    pMain.add("North",lHeader1);
    pMain.add("Center",pCenter);
    pMain.add("South",pSouth);
    add(pMain);

    miExit  = new MenuItem("Exit");
    miAbout = new MenuItem("About");


    Menu mFileMenu = new Menu("File");
    Menu mHelpMenu = new Menu("Help");

    mFileMenu.add(miExit);
    mHelpMenu.add(miAbout);

    MenuBar mb = new MenuBar();
    mb.add(mFileMenu);
    mb.add(mHelpMenu);
    this.setMenuBar(mb);
  }
}
