package dot7.PortScanner;


import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class ScannerMain implements WindowListener, ActionListener
{
  private ScannerGUI gui   = null;
  private ResultsGUI res   = null;
  private StatusGUI status = null;
  private InfoGUI    info  = null;


  public static void main(String[] args)
  {
    ScannerMain ps = new ScannerMain();
  }

  /* Window manager */
  public void windowOpened(WindowEvent e) {}
  public void windowIconified(WindowEvent e) {}
  public void windowDeiconified(WindowEvent e) {}
  public void windowActivated(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e) {}
  public void windowClosed(WindowEvent e) {}
  public void windowClosing(WindowEvent e)
  {
    if (e.getSource() == gui)
    {
      this.destroy();
    }
    else if (e.getSource() == res)
    {
      res.setVisible(false);
    }
    else if (e.getSource() == status)
    {
      status.setVisible(false);
    }
  }

 // ActionListener
  public void actionPerformed(ActionEvent e)
  {
    if (e.getSource() == res.bClose())
    {  res.setVisible(false); }
    if (e.getSource() == info.bClose())
    {  info.setVisible(false); }
    else if (e.getSource() == gui.bScan())
    {
      res.setText1("");
      res.setText2("");
      res.setVisible(false);
      status.setVisible(true);
      scan();
    }
    else if ((e.getSource() == gui.bExit())||(e.getSource() == gui.miExit()))
    {  this.destroy(); }
    else if (e.getSource() == gui.miAbout())
    {
      info.viewAbout();
      info.setVisible(true);
    }
  }

  private void scan()
  {
    String host = gui.getHost();
    int min = gui.getMinPort();
    int max = gui.getMaxPort();
    boolean success = false;

    status.setVisible(true);

    if ((host == null)||(host.length() == 0)||host.equals("")||(min<0)||(max<0)||(max<min))
    {
      status.setInvalidData();
    }
    else
    {
      Vector v = new Vector(10,5);

   // Starting scanner Threads
      for (int port = min; port <= max; port++)
      {
        status.setStart(port,min,max);
        Scanner s = new Scanner();
        s.setData(host, port);
        s.start();
        v.addElement(s);
      }

   // getting results of scanner

      if (v == null)
      {
        res.setText1(" Vector is null. Unexpected problem.");
        System.out.println(" Error: Vector is null. Unexpected problem.");
      }
      else if (v.size() == 0)
      {  res.setText1(" No ports checked."); }
      else
      {
        while (v.size() > 0)
        {
          status.setWaitFor((max-v.size()+1),min,max);
          Scanner s = (Scanner)v.elementAt(0);

          if (s.isCompleted())
          {
            if (s.getSuccess() == true)
            {  res.addText1(s.getSocketNo()); }
            else
            {  res.addText2(s.getSocketNo()); }
            v.removeElementAt(0);
          }
          else
          {
            try
            {  s.join(); }
            catch (InterruptedException e)
            {  System.out.println("InterruptedException: "+e.toString()); }
          }
        }
      }
      status.setVisible(false);
      res.setVisible(true);
    }
  }

  public ScannerMain()
  {
    gui    = new ScannerGUI();
    res    = new ResultsGUI();
    status = new StatusGUI();
    info   = new InfoGUI();
    gui.addWindowListener(this);
    res.addWindowListener(this);
    status.addWindowListener(this);
    info.addWindowListener(this);
    gui.bScan().addActionListener(this);
    gui.bExit().addActionListener(this);
    gui.miExit().addActionListener(this);
    gui.miAbout().addActionListener(this);
    res.bClose().addActionListener(this);
    info.bClose().addActionListener(this);

    gui.setSize(350,200);
    res.setSize(350,350);
    status.setSize(300,100);
    info.setSize(400,200);
    gui.setLocation(new Point(200,100));
    res.setLocation(new Point(400,200));
    status.setLocation(new Point(350,350));
    info.setLocation(new Point(300,300));

    gui.setVisible(true);
  }

  public void destroy()
  {
    gui.removeWindowListener(this);
    res.removeWindowListener(this);
    status.removeWindowListener(this);
    info.removeWindowListener(this);
    gui.bScan().removeActionListener(this);
    gui.bExit().removeActionListener(this);
    gui.miExit().removeActionListener(this);
    gui.miAbout().removeActionListener(this);
    res.bClose().removeActionListener(this);
    info.bClose().removeActionListener(this);
    gui.setVisible(false);
    res.setVisible(false);
    status.setVisible(false);
    gui.dispose();
    res.dispose();
    status.dispose();
    gui = null;
    res = null;
    status = null;
    System.out.println("Have a nice day...");
    System.exit(0);
  }
}
